/** \file HttpDebugSocket.h
 **	\date  2004-09-27
**/
/*
Copyright (C) 2004,2005  Anders Hedstrm (grymse@alhem.net)

This library is made available under the terms of the GNU GPL.

If you would like to use this library in a closed-source application,
a separate license agreement is available. For information about 
the closed-source license agreement for the C++ sockets library,
please visit http://www.alhem.net/Sockets/license.html and/or
email license@alhem.net.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#ifndef _HttpDebugSocket_H
#define _HttpDebugSocket_H

#include "HTTPSocket.h"

#ifdef SOCKETS_NAMESPACE
namespace SOCKETS_NAMESPACE {
#endif

class SocketHandler;

/** HTTP request "echo" class. This class echoes a http request/body
with a html formatted page. 
	\ingroup http */
class HttpDebugSocket : public HTTPSocket
{
public:
	HttpDebugSocket(SocketHandler&);
	~HttpDebugSocket();

	void OnFirst();
	void OnHeader(const std::string& key,const std::string& value);
	void OnHeaderComplete();
	void OnData(const char *,size_t);

private:
	int m_content_length;
	int m_read_ptr;
};


#ifdef SOCKETS_NAMESPACE
}
#endif

#endif // _HttpDebugSocket_H
